import java.io.*;

class tunnel implements Runnable {
	private static boolean LOG=false;
	private InputStream in=null;
	private OutputStream out=null;
	private boolean active=false;
	private duplex dpx=null;

	private String fo=null;
	private FileOutputStream fwriter=null;

	public tunnel(duplex dpx,InputStream in, OutputStream out) {
		this.in = in;
		this.out = out;
		this.dpx = dpx;
		active=true;

		/** explore **/
		if (LOG) {
			fo=Integer.toString((int)(Math.random()*100000))+"-"+Integer.toString((int)(Math.random()*100000))+".log";
			System.out.println("keeping log in "+fo);
			try {
				fwriter = new FileOutputStream(fo);
			}
			catch (IOException e) {
				System.err.println(e);
			}
		}
	}

	public void run() {
		int len=0;
		byte[] c = new byte[255];
		try {
			while (active) {
				if ((len=in.read(c)) > 0) {
					if (LOG)
						fwriter.write(c,0,len);
					out.write(c,0,len);
				}
				else {
					active = false;
				}
				out.flush();
			}
		}
		catch (IOException e) {
			active=false;
		}
		dpx.close();
		try {
			if (LOG && fwriter!=null)
				fwriter.close();
		} catch (IOException e) {  }
	}

	public void stop() {
		active=false;
	}
}
